#include <sys/os32.h>
#include <kernel/net/arp.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int             fd;
  ssize_t         size_read;
  char            buffer[sizeof (arp_t)];
  int             a;
  arp_t          *arp_table_item;
  //
  // All options are ignored.
  //
  // Open `/dev/kmem_arp', to get the ARP table.
  //
  fd = open ("/dev/kmem_arp", O_RDONLY);
  if (fd < 0)
    {
      printf ("[%s] Cannot open \"/dev/kmem_arp\" ", argv[0]);
      perror (NULL);
      exit (0);
    }
  //
  // Scan ARP items and then print body.
  //
  for (a = 0; a < ARP_MAX_ITEMS; a++)
    {
      lseek (fd, (off_t) a, SEEK_SET);
      size_read = read (fd, buffer, sizeof (arp_t));
      if (size_read < sizeof (arp_t))
        {
          printf ("[%s] Cannot read \"/dev/kmem_arp\" item %i ",
                  argv[0], a);
          perror (NULL);
          continue;
        }
      arp_table_item = (arp_t *) buffer;
      if (arp_table_item->time > 0)
        {
          printf ("%i.%i.%i.%i  ",
                  arp_table_item->ip >> 24 & 0x000000FF,
                  arp_table_item->ip >> 16 & 0x000000FF,
                  arp_table_item->ip >>  8 & 0x000000FF,
                  arp_table_item->ip >>  0 & 0x000000FF);
          //
          printf ("%02x:%02x:%02x:%02x:%02x:%02x  ",
                  arp_table_item->mac[0],
                  arp_table_item->mac[1],
                  arp_table_item->mac[2],
                  arp_table_item->mac[3],
                  arp_table_item->mac[4],
                  arp_table_item->mac[5]);
          //
          printf ("%3us\n",
                  (unsigned int) (time (NULL) - arp_table_item->time));
        }
    }
  close (fd);
  return (0);
}
