#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <libgen.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <stdint.h>
#include <stdbool.h>
//----------------------------------------------------------------------
static void usage (void);
//----------------------------------------------------------------------
int
main (int argc, char *argv[], char *envp[])
{
  int                status;
  int                sfdn;
  struct sockaddr_in sa_local;
  ssize_t            recv_size;
  char               buffer[BUFSIZ];
  char              *addr = NULL;
  char              *port = NULL;
  //
  // Arguments.
  //
  if (argc == 3)
    {
      //
      // There are exactly two arguments: destination address and port.
      //
      addr = argv[1];
      port = argv[2];
    }
  else
    {
      //
      // Arguments wrong!
      //
      usage ();
      return (4);
    }
  //
  // Define the destination `sa_local'
  //
  sa_local.sin_family = AF_INET;
  sa_local.sin_port   = htons (atoi (port));
  inet_pton (AF_INET, addr, &sa_local.sin_addr.s_addr);
  //
  // Open the socket.
  //
  sfdn = socket (AF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if (sfdn < 0)
    {
      perror (NULL);
      return (5);
    }
  //
  // Bind the local `sa' location.
  //
  status = bind (sfdn, (struct sockaddr *) &sa_local,
                 sizeof (sa_local));
  if (status < 0)
    {
      perror (NULL);
      close (sfdn);
      return (7);
    }
  //
  // Will read from the remote and show to the screen.
  //
  while (1)
    {
      recv_size = read (sfdn, &buffer, (size_t) BUFSIZ-1);
      if (recv_size < 0)
        {
          perror (NULL);
          close (sfdn);
          return (10);
        }
      buffer[recv_size] = 0;
      printf ("%s", buffer);
    }
  //
  // All done.
  //
  return (0);
}
//----------------------------------------------------------------------
static void
usage (void)
{
  fprintf (stderr, "Usage: rx_udp LOCAL_ADDR LOCAL_PORT\n");
}
