#include <kernel/driver/screen.h>
#include <errno.h>
//----------------------------------------------------------------------
int
screen_new_line (screen_t *screen)
{
    int row;
    //
    // Check argument.
    //
    if (screen == NULL)
      {
        errset (EINVAL);
        return (-1);
      }
    //
    // Find row position on screen.
    //
    row = (screen->position / SCREEN_COLS);
    //
    // We want to go one row down.
    //
    row++;
    //
    // Scroll the screen if necessary.
    //
    for (; row >= SCREEN_ROWS; row--)
      {
        screen_scroll (screen);
      }
    //
    // Reset position at the beginning of the line.
    //
    screen->position = row * SCREEN_COLS;
    //
    // Update the video if it is the current one. This is necessary to
    // update the cursor position, if the original column was not zero.
    //
    screen_update (screen);
    //
    // Ok.
    //
    return (0);
}
