#include <kernel/driver/screen.h>
#include <kernel/ibm_i386.h>
#include <stddef.h>
//----------------------------------------------------------------------
void
screen_update (screen_t *screen)
{
    screen_t     *screen_showing;
    int           j;
    unsigned char position_high;
    unsigned char position_low;
    //
    // Check input: if it is the NULL pointer, or it is not a valid
    // pointer, then select the current screen.
    //
    if ((screen == NULL) || (screen_number (screen) < 0))
      {
        screen = screen_current ();
      }
    //
    // Get current screen anyway.
    //
    screen_showing = screen_current ();
    //
    // Verify again to be in a valid screen.
    //
    if (screen_number (screen_showing) < 0)
      {
        return;
      }
    //
    // If the selected screen is also the current screen, then
    // must update the content (otherwise there is nothing to do).
    //
    if (screen_showing == screen)
      {
        //
        // Copy virtual screen to real screen memory.
        //
        for (j = 0; j < SCREEN_CELLS; j++)
          {
            VGA_CELL[j] = screen->cell[j];
          }
        //
        // Place the cursor.
        //
        position_high = (unsigned char) (screen->position >> 8);
        position_low  = (unsigned char) (screen->position);
        //
        out_8 (0x3D4, 0x0E);
        out_8 (0x3D5, position_high);
        out_8 (0x3D4, 0x0F);
        out_8 (0x3D5, position_low);
      }
}
