#include <kernel/multiboot.h>
#include <string.h>
#include <kernel/lib_k.h>
//----------------------------------------------------------------------
void
mboot_save (multiboot_t *mboot_data)
{
    multiboot.flags = mboot_data->flags;
    //
    if ((mboot_data->flags & 1) > 0)
      {
        multiboot.mem_lower = mboot_data->mem_lower;
        multiboot.mem_upper = mboot_data->mem_upper;
      }
    if ((mboot_data->flags & 2) > 0)
      {
        multiboot.boot_device = mboot_data->boot_device;
      }
    if ((mboot_data->flags & 4) > 0)
      {
        strncpy (multiboot.cmdline, mboot_data->cmdline,
                 MBOOT_CMDLINE_MAX);
      }
    else
      {
        memset (multiboot.cmdline, 0, MBOOT_CMDLINE_MAX);
      }
}
