#include <sys/os32.h>
#include <kernel/net/arp.h>
#include <kernel/driver/nic/ne2k.h>
#include <kernel/driver/pci.h>
#include <kernel/ibm_i386.h>
#include <errno.h>
//----------------------------------------------------------------------
extern arp_t arp_table[ARP_MAX_ITEMS];
//----------------------------------------------------------------------
int
arp_index (unsigned char mac[6], h_addr_t ip)
{
  //
  int a;
  //
  // By mac address.
  //
  if (mac != NULL)
    {
      for (a = 0; a < ARP_MAX_ITEMS; a++)
        {
          if ( arp_table[a].mac[0] == mac[0]
            && arp_table[a].mac[1] == mac[1]
            && arp_table[a].mac[2] == mac[2]
            && arp_table[a].mac[3] == mac[3]
            && arp_table[a].mac[4] == mac[4]
            && arp_table[a].mac[5] == mac[5])
            {
              return (a);
            }
        }
    }
  //
  // By IPv4 address.
  //
  if (ip != 0)
    {
      for (a = 0; a < ARP_MAX_ITEMS; a++)
        {
          if (arp_table[a].ip == ip)
            {
              return (a);
            }
        }
    }
  //
  // Not found!
  //
  errset (ENODEV);
  return (-1);
}
