#include <sys/os32.h>
#include <kernel/lib_k.h>
#include <arpa/inet.h>
#include <kernel/net.h>
#include <kernel/net/ip.h>
#include <kernel/net/icmp.h>
#include <errno.h>
//----------------------------------------------------------------------
#define DEBUG 0
//----------------------------------------------------------------------
int
icmp_tx_echo (h_addr_t src, h_addr_t dst, int type, int code,
              int identifier, int sequence, uint8_t *data, size_t size)
{
  icmp_packet_t icmp;
  //
  // Check the data size.
  //
  if (size > ICMP_MAX_DATA_SIZE)
    {
      errset (EINVAL);
      return (-1);
    }
  //
  // Prepare the packet.
  //
  icmp.header.un.echo.id       = htons (identifier);
  icmp.header.un.echo.sequence = htons (sequence);
  //
  memcpy (icmp.data, data, size);
  //
  // Send to the lower network level.
  //
  return (icmp_tx (src, dst, type, code, (void *) &icmp,
                   (sizeof (struct icmphdr) + size)));
}
