#include <kernel/net.h>
#include <kernel/net/arp.h>
#include <kernel/lib_k.h>
#include <kernel/net/ip.h>
#include <sys/os32.h>
//----------------------------------------------------------------------
ip_t *
ip_reference (void)
{
  int     i;          // IP table index.
  clock_t older;
  int     o;         // Older IP table index.
  //
  older = ip_table[0].clock;
  o     = 0;
  //
  for (i = 0; i < IP_MAX_PACKETS; i++)
    {
      if (ip_table[i].clock == 0)
        {
          //
          // Enough.
          //
          return (&ip_table[i]);
        }
      //
      if (ip_table[i].clock < older)
        {
          older = ip_table[i].clock;
          o = i;
        }
    }
  //
  return (&ip_table[o]);
}
