#include <arpa/inet.h>
#include <sys/os32.h>
#include <kernel/net/route.h>
#include <kernel/lib_k.h>
#include <errno.h>
//----------------------------------------------------------------------
void
route_print (void)
{
  int  r;        // Routing table index.
  char string[80];
  //
  k_printf ("Destination/mask   "
            "Router          "
            "Interface\n");
  //
  for (r = 0; r < ROUTE_MAX_ROUTES; r++)
    {
      if (route_table[r].network == 0xFFFFFFFF)
        {
          //
          // Empty item.
          //
          continue;
        }
      //
      sprintf (string, "%i.%i.%i.%i/%i"
                       "                    ",
               route_table[r].network >> 24 & 0x000000FF,
               route_table[r].network >> 16 & 0x000000FF,
               route_table[r].network >>  8 & 0x000000FF,
               route_table[r].network >>  0 & 0x000000FF,
               route_table[r].m);
      string[19] = '\0';
      k_printf ("%s", string);
      //
      if (route_table[r].router == 0)
        {
          k_printf ("                ");
        }
      else
        {
          sprintf (string, "%i.%i.%i.%i"
                           "           ",
                   route_table[r].router >> 24 & 0x000000FF,
                   route_table[r].router >> 16 & 0x000000FF,
                   route_table[r].router >>  8 & 0x000000FF,
                   route_table[r].router >>  0 & 0x000000FF);
          string[16] = '\0';
          k_printf ("%s", string);
        }
      //
      k_printf ("net%i\n", route_table[r].interface);
    }
}
