#include <_gcc.h>
//----------------------------------------------------------------------
// DIVIDEND = DIVISOR * QUOTIENT + REMINDER
//
// If DIVISOR == 0, then QUOTIENT == 0 and REMINDER == DIVIDEND
//----------------------------------------------------------------------
ulldiv_t
_ulldiv (unsigned long long int dividend,
         unsigned long long int divisor)
{
    unsigned long long int sign;
    unsigned long long int mask;
    ulldiv_t               result;
    int                    scroll;
    unsigned int           size;        // Bits of a long long.
    //
    // Division of zero will return zero.
    //
    if (dividend == 0)
      {
        result.quot = 0;
        result.rem  = 0;
        return (result);
      }
    //
    // Division by zero will return zero and all reminder.
    //
    if (divisor == 0)
      {
        result.quot = 0;
        result.rem  = dividend;
        return (result);
      }
    //
    // Calculate how much bits does have the type `long long'.
    //
    size = 0;
    mask = ~0LL;
    //
    while (mask > 0)
      {
        size += 8;
        mask >>= 8;
      }
    //
    // Calculate the value for `sign' that needs to have the most
    // significant bit to one.
    //
    mask = ~0LL;
    mask >>= 1;
    sign = ~mask;
    //
    // Scroll divisor to the left, as long as the first bit is zero.
    //
    for (scroll = 0; scroll < size; scroll++)
      {
        if (divisor & sign)
          {
            //
            // The most significant bit is one.
            //
            break;
          }
        //
        // The most significant bit is zero: scroll left.
        //
        divisor <<= 1;
      }
    //
    //
    //
    result.quot = 0;
    result.rem  = 0;
    //
    for (; scroll >= 0 && divisor > 0; scroll--)
      {
        result.quot <<= 1;
        if (dividend >= divisor)
          {
            result.quot |=  1LL;
            dividend -= divisor;
          }
        divisor >>= 1;
      }
    //
    result.rem = dividend;
    //
    return (result);
}
