#include <arpa/inet.h>
#include <stdint.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
//----------------------------------------------------------------------
const char *
inet_ntop (int family, const void *src, char *dst, socklen_t size)
{
  //
  // Check family type: only IPv4 is available here.
  //
  if (family != AF_INET)
    {
      errset (EAFNOSUPPORT);
      return (NULL);
    }
  //
  // Check for NULL pointers.
  //
  if (src == NULL || dst == NULL)
    {
      errset (EINVAL);
      return (NULL);
    }
  //
  snprintf (dst, (size_t) size, "%i.%i.%i.%i",
            *((in_addr_t *) src) >>  0 & 0x000000FF,
            *((in_addr_t *) src) >>  8 & 0x000000FF,
            *((in_addr_t *) src) >> 16 & 0x000000FF,
            *((in_addr_t *) src) >> 24 & 0x000000FF);
  //
  // Return ok.
  //
  return (dst);
}
