#include <fcntl.h>
#include <stdarg.h>
#include <stddef.h>
#include <string.h>
#include <errno.h>
#include <sys/os32.h>
#include <limits.h>
//----------------------------------------------------------------------
int
fcntl (int fdn, int cmd, ...)
{
    va_list ap;
    sysmsg_fcntl_t msg;
    va_start (ap, cmd);
    //
    // Well known arguments.
    //
    msg.fdn = fdn;
    msg.cmd = cmd;
    //
    // Select other arguments.
    //
    switch (cmd)
      {
        case F_DUPFD:
        case F_SETFD:
        case F_SETFL:
            msg.arg = va_arg (ap, int);
            break;
        case F_GETFD:
        case F_GETFL:
            break;
        case F_GETOWN:
        case F_SETOWN:
        case F_GETLK:
        case F_SETLK:
        case F_SETLKW:
            errset (E_NOT_IMPLEMENTED);         // Not implemented.
            return (-1);
        default:
            errset (EINVAL);                    // Not implemented.
            return (-1);
      }
    //
    // Do the system call.
    //
    sys (SYS_FCNTL, &msg, (sizeof msg));
    errno = msg.errno;
    errln = msg.errln;
    strncpy (errfn, msg.errfn, PATH_MAX);
    return (msg.ret);
}
