#ifndef _SIGNAL_H
#define _SIGNAL_H       1
//----------------------------------------------------------------------
#include <sys/types.h>
//----------------------------------------------------------------------
#define SIGHUP           1
#define SIGINT           2
#define SIGQUIT          3
#define SIGILL           4
#define SIGABRT          6
#define SIGFPE           8
#define SIGKILL          9
#define SIGSEGV         11
#define SIGPIPE         13
#define SIGALRM         14
#define SIGTERM         15
#define SIGSTOP         17
#define SIGTSTP         18
#define SIGCONT         19
#define SIGCHLD         20
#define SIGTTIN         21
#define SIGTTOU         22
#define SIGUSR1         30
#define SIGUSR2         31
//----------------------------------------------------------------------
typedef int sig_atomic_t;
typedef void (*sighandler_t) (int); // The type `sighandler_t' is a
                                    // pointer to a function for the
                                    // signal handling, with a parameter
                                    // of type `int', returning `void'.
//
// Special function used to call the real signal handler.
// This function will return to the `back' address, instead
// where it was called.
//
void _sighandler_wrapper (uint32_t handler, uint32_t signal,
                          uint32_t back);
//
// Special undeclarable functions.
//
#define SIG_ERR ((sighandler_t) -1) // It transform an integer number
#define SIG_DFL ((sighandler_t) 0)  // into a `sighandler_t' type,
#define SIG_IGN ((sighandler_t) 1)  // that is, a pointer to a function
                                    // that does not exists really.
//----------------------------------------------------------------------
sighandler_t signal (int sig, sighandler_t handler);
int          kill   (pid_t pid, int sig);
int          raise  (int sig);
//----------------------------------------------------------------------
#endif
