#include <stdlib.h>
#include <string.h>
//----------------------------------------------------------------------
extern char *_environment[];
//----------------------------------------------------------------------
char *
getenv (const char *name)
{
    int   e;        // First index: environment table items.
    int   f;        // Second index: environment string scan.
    char *value;    // Pointer to the environment value found.
    //
    // Check if the input is valid. No error is reported.
    //
    if (name == NULL || strlen (name) == 0)
      {
        return (NULL);
      }
    //
    // Scan the environment table items, with index `e'. The pointer
    // `value' is initialized to NULL. If the pointer `value' gets a
    // valid  pointer, the environment variable was found and a
    // pointer to the beginning of its value is available.
    //
    for (value = NULL, e = 0; e < ARG_MAX/32; e++)
      {
        //
        // Scan the string of the environment item, with index `f'.
        // The scan continue until `name[f]' and `_environment[e][f]'
        // are equal.
        //
        for (f = 0;
             f < ARG_MAX/16-1 && name[f] == _environment[e][f];
             f++)
          {
            ; // Just scan.
          }
        //
        // At this point, `name[f]' and `_environment[e][f]' are
        // different: if `name[f]' is zero the name string is
        // terminated; if `_environment[e][f]' is also equal to `=',
        // the environment item is corresponding to the requested name.
        //
        if (name[f] == 0 && _environment[e][f] == '=')
          {
            //
            // The pointer to the beginning of the environment value is
            // calculated, and the external loop exit.
            //
            value = &_environment[e][f+1];
            break;
          }
      }
    //
    // The `value' is returned: if it is still NULL, then, no
    // environment variable with the requested name was found.
    //
    return (value);
}
