#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
//----------------------------------------------------------------------
extern uintptr_t _alloc_start;
//----------------------------------------------------------------------
void *
realloc (void *ptr, size_t size)
{
    uintptr_t      start       = _alloc_start;
    uintptr_t      end         = (uintptr_t) sbrk (0);
    size_t         actual_size;
    _alloc_head_t *head        = ((_alloc_head_t *) ptr) - 1;
    _alloc_head_t *head_new;
    void          *ptr_new;
    //
    // Verifica che il puntatore riguardi effettivamente
    // un'area occupata.
    //
    if (! head->allocated)
      {
        printf ("[%s] ERROR: cannot re-allocate %08X that is "
                "not already allocated!", __func__, (uintptr_t) ptr);
      }
    //
    // Arrotonda in eccesso il valore di «size», in modo che sia un
    // multiplo della dimensione di «_alloc_head_t». Altrimenti, la
    // collocazione dei blocchi successivi può avvenire in modo
    // non allineato.
    //
    size = (size + (sizeof (_alloc_head_t)) -1);
    size = size / (sizeof (_alloc_head_t));
    size = size * (sizeof (_alloc_head_t));
    //
    // Determina la dimensione attuale.
    //
    if ((head->next * (sizeof (_alloc_head_t))) == start)
      {
        actual_size = end - ((uintptr_t) ptr);
      }
    else
      {
        actual_size =   (head->next * (sizeof (_alloc_head_t)))
                      - ((uintptr_t) ptr);
      }
    //
    // Se la dimensione richiesta è inferiore, può ridurre
    // l'estensione del blocco.
    //
    if (size == actual_size)
      {
        return ptr;
      }
    else if (size <= (actual_size - (sizeof (_alloc_head_t)) * 2))
      {
        //
        // Si può ricavare lo spazio libero rimanente.
        //
        head_new = (_alloc_head_t *) (((char *) ptr) + size);
        //
        head_new->next = head->next;
        head_new->allocated=0;
        //
        head->next = ((uintptr_t) head_new) / (sizeof (_alloc_head_t));
        //
        return ptr;
      }
    else if (size < actual_size)
      {
        //
        // Anche se è minore, non si può ridurre lo spazio usato
        // effettivamente.
        //
        return ptr;
      }
    else
      {
        //
        // La dimensione richiesta è maggiore.
        //
        ptr_new = malloc (size);
        //
        if (ptr_new)
          {
            //
            // Ricopia i dati nella nuova collocazione.
            //
            memcpy (ptr_new, ptr, actual_size);
            //
            // Libera la collocazione vecchia.
            //
            free (ptr);
            //
            return ptr_new;
          }
        else
          {
            return NULL;
          }
      }
}
