#include <sys/os32.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
//----------------------------------------------------------------------
int
accept (int sfdn, struct sockaddr *addr, socklen_t *addrlen)
{
    sysmsg_accept_t msg;
    //
    // Fill the message.
    //
    msg.sfdn     = sfdn;
    memset (&msg.addr, 0x00, sizeof (msg.addr));
    msg.addrlen  = *addrlen;
    msg.fl_flags = 0;           // Not necessary.
    msg.ret      = 0;
    //
    // Syscall.
    //
    while (1)
      {
        sys (SYS_ACCEPT, &msg, (sizeof msg));
        //
        if (msg.ret < 0
            && (msg.errno == EAGAIN || msg.errno == EWOULDBLOCK))
          {
            //
            // No request at the moment.
            //
            if (msg.fl_flags & O_NONBLOCK)
              {
                //
                // Don't block.
                //
                break;
              }
            else
              {
                //
                // Keep trying.
                //
                continue;
              }
          }
        else
          {
            break;
          }
      }
    //
    // Check return value.
    //
    if (msg.ret < 0)
      {
        //
        // Something wrong.
        //
        errno = msg.errno;
        errln = msg.errln;
	strncpy (errfn, msg.errfn, PATH_MAX);
      }
    else
      {
        //
        // Update the socket address and the address length.
        //
        if (addrlen != NULL && addr != NULL && *addrlen > 0)
          {
            memcpy (addr, &msg.addr, min (msg.addrlen, *addrlen));
            *addrlen = msg.addrlen;
          }
      }
    //
    // Return.
    //
    return (msg.ret);
}
