#include <unistd.h>
#include <sys/os32.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
//----------------------------------------------------------------------
ssize_t
send (int sfdn, const void *buffer, size_t count, int flags)
{
    sysmsg_send_t msg;
    int           retry = 3;
    //
    // Reduce size of write if necessary.
    //
    if (count > BUFSIZ)
      {
        count = BUFSIZ;
      }
    //
    // Fill the message.
    //
    msg.sfdn  = sfdn;
    msg.buffer = buffer;
    msg.count = count;
    msg.flags = flags;
    //
    // Syscall.
    //
    for (; retry > 0; retry--)
      {
        sys (SYS_SEND, &msg, (sizeof msg));
        //
        // Check.
        //
        if ((msg.ret < 0) && (msg.errno == E_ARP_MISSING))
          {
            sleep (1);
            continue;       // Retry.
          }
        else
          {
            break;
          }
      }
    //
    // Check the final result and return.
    //
    if (msg.ret < 0)
      {
        //
        // No valid write.
        //
        errno = msg.errno;
        errln = msg.errln;
    	strncpy (errfn, msg.errfn, PATH_MAX);
        return (msg.ret);
      }
    //
    if (msg.ret > count)
      {
        //
        // A strange value was returned. Considering it a read error.
        //
        errset (EIO);                   // I/O error.
        return (-1);
      }
    //
    // A valid write return.
    //
    return (msg.ret);
}
